#line 1 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 27 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
typedef struct
{
 unsigned short RTC_Hour_Tens;
 unsigned short RTC_Hour_Units;
 unsigned short RTC_Min_Tens;
 unsigned short RTC_Min_Units;
 unsigned short RTC_Sec_Tens;
 unsigned short RTC_Sec_Units;
 unsigned short RTC_H12;
}RTC_TimeTypeDef;


typedef struct
{
 unsigned short RTC_DayofWeek;
 unsigned short RTC_Date_Tens;
 unsigned short RTC_Date_Units;
 unsigned short RTC_Month_Tens;
 unsigned short RTC_Month_Units;
 unsigned short RTC_Year_Tens;
 unsigned short RTC_Year_Units;
}RTC_DateTypeDef;
#line 56 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
void Message (char arg[])
{
 UART2_Write(13);
 UART2_Write(10);
 UART2_Write_Text(arg);
 UART2_Write(13);
 UART2_Write(10);
}
#line 75 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
short RTC_Init(unsigned PREDIV_Sync, unsigned short PREDIV_Async, int HR_Format)
{
 unsigned short RTC_Wait_ctr = 0;



 BDRST_bit = 1;
 Delay_ms(1);
 BDRST_bit = 0;
 Delay_ms(1);



 PWREN_bit = 1;
 DBP_bit = 1;
 RTCSEL1_bit = 0; RTCSEL0_bit = 1;
 LSEBYP_bit = 0;
 LSEON_bit = 1;
 RTCEN_bit = 1;



 DBP_bit = 1;
 RTC_WPR = 0xCA;
 RTC_WPR = 0x53;


 while ((LSERDY_bit == 0) && (RTC_Wait_ctr < 150));
 {
 delay_us(1);
 RTC_Wait_ctr++;
 }

 if (LSERDY_bit == 0) Message("LSE Clock not ready.");


 RTC_Wait_ctr = 0;



 if (INITF_bit == 0)
 {
 RTC_ISR.B7 = 1;
 while ((INITF_bit == 0) && (RTC_Wait_ctr < 8))
 {
 delay_us(10);
 RTC_Wait_ctr++;
 }

 if (INITF_bit == 0)
 {
 Message("Failed to enter INIT mode.");
 RTC_ISR.B7 = 0;
 RTC_WPR = 0xFF;
 return 0;
 }
 }


 RTC_PRERbits.PREDIV_S = PREDIV_Sync;
 RTC_PRERbits.PREDIV_A = PREDIV_Async;


 FMT_bit = HR_Format;


 RTC_ISR.B7 = 0;




 RTC_WPR = 0xFF;

 return 1;
}
#line 159 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
short RTC_SetTime(RTC_TimeTypeDef *RTC_TimeStruct)
{
 short Func_Status;
 unsigned short RTC_Wait_ctr = 0;
 unsigned long Temp_Time_Reg = 0;
#line 171 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
 Temp_Time_Reg = (((unsigned long) (RTC_TimeStruct->RTC_H12) << 22) | ((unsigned long) (RTC_TimeStruct->RTC_Hour_Tens) << 20) | ((unsigned long) (RTC_TimeStruct->RTC_Hour_Units) << 16) | ((unsigned long) (RTC_TimeStruct->RTC_Min_Tens) << 12) | ((unsigned long) (RTC_TimeStruct->RTC_Min_Units) << 8) | ((unsigned long) (RTC_TimeStruct->RTC_Sec_Tens) << 4) | ((unsigned long) (RTC_TimeStruct->RTC_Sec_Units)));



 RTC_WPR = 0xCA;
 RTC_WPR = 0x53;
 DBP_bit = 1;


 if (INITF_bit == 0) {

 RTC_ISR.B7 = 1;

 while ((INITF_bit == 0) && (RTC_Wait_ctr < 8))
 {
 delay_us(10);
 RTC_Wait_ctr++;
 }

 if (INITF_bit == 0)
 {
 Message("Failed to enter INIT mode.");
 Func_Status = 0;
 }
 }
 RTC_Wait_ctr = 0;


 RTC_TR = Temp_Time_Reg;


 RTC_ISR.B7 = 0;




 RTC_WPR = 0xFF;

 return Func_Status;
}
#line 219 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
short RTC_SetDate(RTC_DateTypeDef *RTC_DateStruct)
{
 short Func_Status;
 unsigned short RTC_Wait_ctr = 0;
 unsigned long Temp_Date_Reg = 0;
#line 231 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
 Temp_Date_Reg = (((unsigned long) (RTC_DateStruct->RTC_Year_Tens) << 20) | ((unsigned long) (RTC_DateStruct->RTC_Year_Units) << 16) | ((unsigned long) (RTC_DateStruct->RTC_DayofWeek) << 13) | ((unsigned long) (RTC_DateStruct->RTC_Month_Tens) << 12) | ((unsigned long) (RTC_DateStruct->RTC_Month_Units) << 8) | ((unsigned long) (RTC_DateStruct->RTC_Date_Tens) << 4) | ((unsigned long) (RTC_DateStruct->RTC_Date_Units)));

 Temp_Date_Reg = Temp_Date_Reg & 0x00FFFFFF;


 RTC_WPR = 0xCA;
 RTC_WPR = 0x53;
 DBP_bit = 1;


 if (INITF_bit == 0) {

 RTC_ISR.B7 = 1;

 while ((INITF_bit == 0) && (RTC_Wait_ctr < 8))
 {
 delay_us(10);
 RTC_Wait_ctr++;
 }

 if (INITF_bit == 0)
 {
 Message("Failed to enter INIT mode.");
 Func_Status = 0;
 }
 }
 RTC_Wait_ctr = 0;


 RTC_DR = Temp_Date_Reg;


 RTC_ISR.B7 = 0;




 RTC_WPR = 0xFF;

}
#line 280 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
unsigned RTC_GetSubSeconds(void)
{
 unsigned long Temp_RTC_SSR;
 float Temp_float;

 Temp_RTC_SSR = RTC_SSR;
 Temp_RTC_SSR = Temp_RTC_SSR & 0x0000FFFF;
 Temp_float = 1000 * ((float) Temp_RTC_SSR) / ((float) RTC_PRERbits.PREDIV_S);


 (void) RTC_DR;

 return (unsigned) Temp_float;
}
#line 301 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
void RTC_GetTime(RTC_TimeTypeDef *RTC_TimeStruct)
{

 RTC_TimeStruct->RTC_H12 = (unsigned short) RTC_TRbits.PM;
 RTC_TimeStruct->RTC_Hour_Tens = (unsigned short) RTC_TRbits.HT;
 RTC_TimeStruct->RTC_Hour_Units = (unsigned short) RTC_TRbits.HU;
 RTC_TimeStruct->RTC_Min_Tens = (unsigned short) RTC_TRbits.MNT;
 RTC_TimeStruct->RTC_Min_Units = (unsigned short) RTC_TRbits.MNU;
 RTC_TimeStruct->RTC_Sec_Tens = (unsigned short) RTC_TRbits.ST;
 RTC_TimeStruct->RTC_Sec_Units = (unsigned short) RTC_TRbits.SU;
}
#line 320 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
void RTC_GetDate(RTC_DateTypeDef *RTC_DateStruct)
{

 RTC_DateStruct->RTC_DayofWeek = (unsigned short) RTC_DRbits.WDU;
 RTC_DateStruct->RTC_Date_Tens = (unsigned short) RTC_DRbits.DT;
 RTC_DateStruct->RTC_Date_Units = (unsigned short) RTC_DRbits.DU;
 RTC_DateStruct->RTC_Month_Tens = (unsigned short) RTC_DRbits.MT;
 RTC_DateStruct->RTC_Month_Units = (unsigned short) RTC_DRbits.MU;
 RTC_DateStruct->RTC_Year_Tens = (unsigned short) RTC_DRbits.YT;
 RTC_DateStruct->RTC_Year_Units = (unsigned short) RTC_DRbits.YU;
}
#line 339 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
void RTC_PrintTime(RTC_TimeTypeDef *RTC_TimeStruct)
{
 char txt[4];

 UART2_Write(13);
 UART2_Write(10);
 ByteToStr(RTC_TimeStruct->RTC_Hour_Tens, txt);
 UART2_Write_Text(txt);
 ByteToStr(RTC_TimeStruct->RTC_Hour_Units, txt);
 txt[0] = txt[2]; txt[1] = txt[3];
 UART2_Write_Text(txt);
 UART2_Write_Text(":");
 ByteToStr(RTC_TimeStruct->RTC_Min_Tens, txt);
 txt[0] = txt[2]; txt[1] = txt[3];
 UART2_Write_Text(txt);
 ByteToStr(RTC_TimeStruct->RTC_Min_Units, txt);
 txt[0] = txt[2]; txt[1] = txt[3];
 UART2_Write_Text(txt);
 UART2_Write_Text(":");
 ByteToStr(RTC_TimeStruct->RTC_Sec_Tens, txt);
 txt[0] = txt[2]; txt[1] = txt[3];
 UART2_Write_Text(txt);
 ByteToStr(RTC_TimeStruct->RTC_Sec_Units, txt);
 txt[0] = txt[2]; txt[1] = txt[3];
 UART2_Write_Text(txt);

 if (RTC_TimeStruct->RTC_H12)
 UART2_Write_Text(" pm");
 else
 UART2_Write_Text(" am");

 UART2_Write(13);
 UART2_Write(10);
}
#line 381 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
void RTC_PrintDate(RTC_DateTypeDef *RTC_DateStruct)
{
 char txt[4];
 unsigned short Temp_Day;

 Temp_Day = RTC_DateStruct->RTC_DayofWeek;

 UART2_Write(13);
 UART2_Write(10);

 switch (Temp_Day) {
 case 1 : UART2_Write_Text("  Mon"); break;
 case 2 : UART2_Write_Text("  Tue"); break;
 case 3 : UART2_Write_Text("  Wed"); break;
 case 4 : UART2_Write_Text("  Thu"); break;
 case 5 : UART2_Write_Text("  Fri"); break;
 case 6 : UART2_Write_Text("  Sat"); break;
 case 7 : UART2_Write_Text("  Sun"); break;
 }

 ByteToStr(RTC_DateStruct->RTC_Date_Tens, txt);
 UART2_Write_Text(txt);
 ByteToStr(RTC_DateStruct->RTC_Date_Units, txt);
 txt[0] = txt[2]; txt[1] = txt[3];
 UART2_Write_Text(txt);
 UART2_Write_Text("/");
 ByteToStr(RTC_DateStruct->RTC_Month_Tens, txt);
 txt[0] = txt[2]; txt[1] = txt[3];
 UART2_Write_Text(txt);
 ByteToStr(RTC_DateStruct->RTC_Month_Units, txt);
 txt[0] = txt[2]; txt[1] = txt[3];
 UART2_Write_Text(txt);
 UART2_Write_Text("/");
 ByteToStr(RTC_DateStruct->RTC_Year_Tens, txt);
 txt[0] = txt[2]; txt[1] = txt[3];
 UART2_Write_Text(txt);
 ByteToStr(RTC_DateStruct->RTC_Year_Units, txt);
 txt[0] = txt[2]; txt[1] = txt[3];
 UART2_Write_Text(txt);

 UART2_Write(13);
 UART2_Write(10);
}
#line 432 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
void Print_Sub_Secs (unsigned Value)
{
 char txt[6];
 WordToStr(Value, txt);
 UART2_Write(13);
 UART2_Write(10);
 UART2_Write_Text(txt);
 UART2_Write_Text("  ms");
 UART2_Write(13);
 UART2_Write(10);
}
#line 448 "C:/Users/Andrew/Dropbox/Hazelton Technologies/Projects/Process Controller/MCU Code/InternalRTC/InternalRTC.c"
void main()
{
 RTC_TimeTypeDef My_Time;
 RTC_TimeTypeDef Read_Time;
 RTC_DateTypeDef My_Date;
 RTC_DateTypeDef Read_Date;
 unsigned Temp_Value;
 char Temp_txt[6];


 GPIO_Set_Pin_Mode(&GPIOC_BASE, _GPIO_PIN_14, _GPIO_CFG_MODE_ALT_FUNCTION);
 GPIO_Set_Pin_Mode(&GPIOC_BASE, _GPIO_PIN_15, _GPIO_CFG_MODE_ALT_FUNCTION);




 GPIO_Alternate_Function_Enable(&_GPIO_MODULE_USART2_PD56);
 UART2_Init(115200);
 Delay_ms(200);

 Message("Program Start.");
 Delay_ms(2000);



 My_Date.RTC_DayofWeek = 2;
 My_Date.RTC_Date_Tens = 3;
 My_Date.RTC_Date_Units = 0;
 My_Date.RTC_Month_Tens = 0;
 My_Date.RTC_Month_Units = 6;
 My_Date.RTC_Year_Tens = 1;
 My_Date.RTC_Year_Units = 5;



 My_Time.RTC_Hour_Tens = 0;
 My_Time.RTC_Hour_Units = 7;
 My_Time.RTC_Min_Tens = 5;
 My_Time.RTC_Min_Units = 8;
 My_Time.RTC_Sec_Tens = 0;
 My_Time.RTC_Sec_Units = 0;
 My_Time.RTC_H12 = 1;


 if (RTC_Init(1024, 34, 1))
 Message("RTC Initialise SUCCESS...");
 else
 Message("RTC Initialise FAILED...");
 Delay_ms(2000);

 if (RTC_SetTime(&My_Time))
 Message("Time Set SUCCESS...");
 else
 Message("Time Set FAILED...");
 Delay_ms(2000);

 RTC_SetDate(&My_Date);

 Temp_Value = RTC_PRERbits.PREDIV_S;
 WordToStr(Temp_Value, Temp_txt);
 Message("PREDIV_S:");
 Message(Temp_txt);



 while(1)
 {
 Print_Sub_Secs( RTC_GetSubSeconds() );
 Delay_ms(10);

 RTC_GetDate(&Read_Date);
 RTC_PrintDate(&Read_Date);
 RTC_GetTime(&Read_Time);
 RTC_PrintTime(&Read_Time);

 Delay_ms(5000);
 }

}
